package imo;

import mine.FreeLayout;

import java.awt.Color;
import java.awt.Component;
import javax.swing.JPanel;

public class MainPanel extends JPanel implements MainWorks {

    ImoListener il;
    UnitPanel up;
    GamePaint gp;
    String name;
    int level;

    /*** Constructer ***************************/

    public MainPanel( ImoListener il, String name, int level ){
	this.il = il;
	this.name = name;
	this.level =level;
	setBackground( new Color( 180, 240, 180 ) );
	Images.setup();
	up = new UnitPanel(this);
	gp = new GamePaint(this);
	setLayout( new FreeLayout( 300, 300 ) );
	add(up);
	up.setPaintListener( new StartPaint(this) );
	up.start();
    }

    /*** Sleep ************************************************/

    public void sleep( long msec ){
	up.sleep(msec);
    }

    /*** Start ******************************************/

    public void gameStart(){
	up.stop();
	gp.resetData(name, level);
	up.setPaintListener(gp);
	up.start();
    }

    /*** End ********************************************/

    public void gameEnd( int n ){
	up.stop();
	Images.setEndImage(n);
	up.setPaintListener( new EndPaint(this, n) );
	up.start();
    }

    /*** Game Exit ***************************************/

    public void gameExit(){
	il.gameExit(gp.getEXP());
    }

}
