package imo;

import mine.RunCanvas;

import java.awt.*;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

public class UnitPanel extends RunCanvas implements KeyListener {

    private MainWorks mw;
    private PaintListener pl;

    /*** Constructer *****************************/

    UnitPanel( MainWorks mw ){
	super( 300, 300 );
	this.mw = mw;
	addKeyListener(this);
    }

    /*** Listener ******************************/
    
    public void setPaintListener( PaintListener pl ){
	this.pl = pl;
    }

    /*** Paint ******************************/

    public void paint( Graphics g ){
	pl.paint(g);
	requestFocus();
    }

    /*** Key **********************************************/

    public void keyTyped( KeyEvent e){}
    public void keyReleased( KeyEvent e ){
	pl.keyReleased(e);
    }
    public void keyPressed( KeyEvent e ){
	pl.keyPressed(e);
    }

    /*** MainLoop *****************************************/

    public void run(){
	pl.run();
    }
}


	
