package mine;

import java.awt.*;
import java.awt.image.*;

public abstract class BufferCanvas extends JCanvas {

    private BufferedImage offi;
    private Graphics2D offg;

    /*** Constructer **************************************/

    public BufferCanvas( int width, int height ){
	super( width, height );
	offi = null;
    }

    /*** Set Size ****************************************/

    public void setSize( int width, int height ){
	super.setSize( width, height );
	offi = null;
    }

    /*** Paint ******************************************/

    public void update( Graphics g ){
	paint(g);
    }
    public void paint( Graphics g ){
	if( offi == null ){
	    offi = new BufferedImage( size.width, size.height, BufferedImage.TYPE_INT_ARGB );
	    offg = (Graphics2D)offi.getGraphics();
	}
	paints(offg);
	g.drawImage( offi, 0, 0, null );
    }
    public abstract void paints( Graphics g );

    /*** Clear ********************************************/

    public void clear(){
	if( offg == null ) return;
	offg.setBackground( new Color( 0, 0, 0, 0 ) );
	offg.clearRect( 0, 0, size.width, size.height );
    }
}
			
