package mine;

import java.awt.*;
import java.io.*;

public class DataStream {

    private static Class c;

    /*** setup ******************************************************/

    public static void setup( Object obj ){
	c = obj.getClass();
    }

    /*** InputStream ************************************************/

    private static ObjectInputStream getInStream( Object fs ) throws Exception {
	try{
	    if( fs instanceof File ){
		FileInputStream fis = new FileInputStream( (File)fs );
		if( fis != null ) return new ObjectInputStream(fis);
	    }
	    else if( fs instanceof String ){
		if( c != null ){
		    InputStream is = c.getResourceAsStream( (String)fs );
		    if( is != null ) return new ObjectInputStream(is);
		}
		FileInputStream fis = new FileInputStream( (String)fs );
		if( fis != null ) return new ObjectInputStream(fis);
	    }
	}catch( FileNotFoundException e ){
	    System.out.println("File not found. ( " + fs + " )");
	}
	return null;
    }

    /*** ObjectRead ******************************/

    public static Object read( Object fs ){
	Object var = null;
	try {
	    ObjectInputStream ois = getInStream(fs);
	    if( ois != null ){
		var = ois.readObject();
		ois.close();
	    }
	}
	catch( Exception e ){
	    e.printStackTrace();
	}
	return var;
    }

    /*** OutputStream ***********************************************/

    private static ObjectOutputStream getOutStream( Object fs ) throws Exception {
	if( fs instanceof File ){
	    FileOutputStream fos = new FileOutputStream( (File)fs );
	    return new ObjectOutputStream(fos);
	}
	else if( fs instanceof String ){
	    FileOutputStream fos = new FileOutputStream( (String)fs );
	    return new ObjectOutputStream(fos);
	}
	return null;
    }
    /*** ObjectWrite *****************************/

    public static void write( Object fs, Object obj ){
	try {
	    ObjectOutputStream oos = getOutStream(fs);
	    if( oos != null ){
		oos.writeObject( obj );
		oos.close();
	    }
	}
	catch( Exception e ){
	    e.printStackTrace();
	}
    }
}
