package mine;

import java.awt.Component;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

public class KeyManager implements KeyListener {

    private boolean keys[];
    private boolean K_UP, K_DOWN, K_LEFT, K_RIGHT;
    private boolean K_ENTER, K_ESCAPE, K_SHIFT, K_SPACE;

    /*** Constructer ********************************/

    public KeyManager(){
	reset();
    }

    public KeyManager( Component c ){
	this();
	c.addKeyListener(this);
    }

    /*** Reset ******************************/

    public void reset(){
	keys = new boolean[256];
	K_UP = false;
	K_DOWN = false;
	K_LEFT = false;
	K_RIGHT = false;
	K_ENTER = false;
	K_ESCAPE = false;
	K_SHIFT = false;
	K_SPACE = false;
    }

    /*** Get Data **********************************/
	
    public boolean isEnter(){
	return K_ENTER;
    }
    public boolean isEscape(){
	return K_ESCAPE;
    }
    public boolean isShift(){
	return K_SHIFT;
    }
    public boolean isSpace(){
	return K_SPACE;
    }
    public boolean isUp(){
	return K_UP;
    }
    public boolean isDown(){
	return K_DOWN;
    }
    public boolean isLeft(){
	return K_LEFT;
    }
    public boolean isRight(){
	return K_RIGHT;
    }
    public boolean isNeutral(){
	if( K_UP ) return false;
	if( K_DOWN ) return false;
	if( K_LEFT ) return false;
	if( K_RIGHT ) return false;
	return true;
    }

    public boolean isKey( char c ){
	int i = (int)c;
	if( i < 256 ){
	    return keys[i];
	}
	return false;
    }

    /*** Key *****************************************/

    public void keyTyped( KeyEvent e ){}
    public void keyPressed( KeyEvent e ){
	setKey(e, true);

    }
    public void keyReleased( KeyEvent e ){
	setKey(e, false);
    }

    /*** Set Key ***************************************/

    private void setKey( KeyEvent e, boolean b ){
	int i = (int)e.getKeyChar();
	if( i < 256 ){
	    keys[i] = b;
	}
	switch (e.getKeyCode()) {
	case KeyEvent.VK_ENTER:   K_ENTER  = b;  break;
	case KeyEvent.VK_ESCAPE:  K_ESCAPE = b;  break;
	case KeyEvent.VK_SHIFT:   K_SHIFT  = b;  break;
	case KeyEvent.VK_SPACE:   K_SPACE  = b;  break;
	case KeyEvent.VK_UP:      K_UP     = b;  break;
	case KeyEvent.VK_DOWN:    K_DOWN   = b;  break;
	case KeyEvent.VK_LEFT:    K_LEFT   = b;  break;
	case KeyEvent.VK_RIGHT:   K_RIGHT  = b;  break;
	}
    }
}
