package mine;

import java.awt.*;
import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;

public class Runner implements Runnable, FocusListener {

    private Thread th = null;
    private Runnable runner;
	
    /*** Constructer ***********************************************/
  
    public Runner( Runnable rc ){
  	this.runner = rc;
  	if( rc instanceof Component ){
	    Component c = (Component)rc;
	    c.addFocusListener(this);
  	}
    }

    /*** Control Thread **********************************************/
  
    public void start(){
	if( th == null ){
	    th = new Thread(this);
	    th.start();
	}
    }
  
    public void stop(){
	th = null;
    }

    /*** MainLoop **********************************************/

    public void run(){
	Thread ths = Thread.currentThread();
	while ( th == ths ) {
	    runner.run();
	    th.yield();
	}
    }

    /*** Sleep *************************************************/

    public static void sleep( long msec ){
	try{
	    Thread.currentThread().sleep( msec );
	}
	catch( Exception e ){
	    e.printStackTrace();
	}
    }
  
    /*** Focus *********************************************/
  
    public void focusGained( FocusEvent e ){
	start();
    }
    public void focusLost( FocusEvent e ){
	stop();
    }
  
}
