package mine;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TextDialog extends JDialog implements ActionListener {

    private JLabel label;
    private JTextField text;
    private boolean life;
    private int size;

    /*** Constructer *******************************/

    public TextDialog( Frame f, int size ){
	super( f, true );
	this.size = size;
	Pinit();
    }
    public TextDialog( Frame f ){
	this(f, 15);
    }


    /*** Setup *********************************/

    public void setup( String title, String def ){
	if (Mine.isWindows()) {
	    setTitle(title);
	} else {
	    setTitle("Java");
	    label.setText("@ " + title);
	}
	text.setText(def);
    }

    /*** Show **************************************/

    public void show(){
	life = false;
	pack();
	Mine.setCenter(this);
	super.show();
    }

    /*** Panel Init ***************************/

    private void Pinit(){
	JButton jb = new JButton("OK");
	jb.addActionListener(this);
	text = new JTextField(size);
	text.addActionListener(this);
	label = new JLabel();
	label.setFont(Mine.getFont(12));
	label.setForeground( Color.white );
	JPanelBase jp = new JPanelBase();
	jp.setBackground( new Color(0, 0, 150) );
	jp.add( label, 1, 1, 2, 1 );
	jp.add( text, 1, 2, 1, 1 );
	jp.add( jb,   2, 2, 1, 1 );
	setContentPane(jp);
    }

    /*** Get Text *****************************/

    public String getText(){
	if( life ) return text.getText();
	return null;
    }

    /*** Press MenuButton **********************************/

    public void actionPerformed( ActionEvent e ){
	life = true;
	dispose();
    }
}
