package mine;

import java.awt.Dimension;
import java.awt.Point;

public class UnitSub {
	
    private UnitMap V;
	
    private int face;             // used in moveS
    static final int F_UP = 0;
    static final int F_DOWN = 1;
    static final int F_LEFT = 2;
    static final int F_RIGHT = 3;

    /*** Constructer *************************************************/

    public UnitSub( UnitMap V ){
	this.V = V;
	face = 0;
    }

    /*** Move by Key ***************************************************/

    public Point moveK( int x, int y,
			boolean u, boolean d, boolean l, boolean r ){

	Dimension map = V.getSize();
	if( u )  y = Math.max( y-1, 0 );
	if( d )  y = Math.min( y+1, map.height-1 );
	if( l )  x = Math.max( x-1, 0 );
	if( r )  x = Math.min( x+1, map.width-1 );
	return new Point( x, y );
    }
	
    /*** Display Position *********************************************/

    public Point getH( int x, int y, int dx, int dy ){
	
	int hjx, hjy;
		
	Dimension map = V.getSize();
	hjx = Mine.mid( 0, x-dx/2, map.width-dx );
	hjy = Mine.mid( 0, y-dy/2, map.height-dy );
	return new Point( hjx, hjy );
    }

    /*** Shortest Root ************************************************/

    public Point moveS( int p, int x, int y ){

	Point next = new Point( x, y );
	int bd = V.G( p, 3, x, y );

	switch( face ){
	case F_UP:
	    bd = moves( p, x, y-1, bd, next, F_UP );
	    break;
	case F_DOWN:
	    bd = moves( p, x, y+1, bd, next, F_DOWN );
	    break;
	case F_LEFT:
	    bd = moves( p, x-1, y, bd, next, F_LEFT );
	    break;
	case F_RIGHT:
	    bd = moves( p, x+1, y, bd, next, F_RIGHT );
	    break;
	default:
	}
	bd = moves( p, x, y-1, bd, next, F_UP );
	bd = moves( p, x, y+1, bd, next, F_DOWN );
	bd = moves( p, x-1, y, bd, next, F_LEFT );	
	bd = moves( p, x+1, y, bd, next, F_RIGHT );
	if( next.x != x ) return next;
	if( next.y != y ) return next;
	return null;
    }
    private int moves( int p, int x, int y, int bd, Point s, int f ){
	int bds = V.G( p, 3, x, y );
	if( bd > bds ){
	    s.x = x;
	    s.y = y;
	    face = f;
	    return bds;
	}
	return bd;
    }		
}

	
